//---------- p_param.cpp -----------------------------------------------------
//----------------------------------------------------------------------------
#include "precHeader.h"
//----------------------------------------------------------------------------
#include "p_param.h"
#include "paramcom.h"
#include "pOwnBtnImage.h"
//----------------------------------------------------------------------------
extern paramCom getDefaultparamCom();
//----------------------------------------------------------------------------
static value_name vPort[] =
{
  { 1,  _T("COM1")  },
  { 2,  _T("COM2")  },
  { 3,  _T("COM3")  },
  { 4,  _T("COM4")  },
  { 5,  _T("COM5")  },
  { 6,  _T("COM6")  },
  { 7,  _T("COM7")  },
  { 8,  _T("COM8")  },
};
//----------------------------------------------------------------------------
static value_name vBaudRate[] =
{
  { CBR_110,        _T("110")   },
  { CBR_300,        _T("300")   },
  { CBR_600,        _T("600")   },
  { CBR_1200,     _T("1.200")   },
  { CBR_2400,     _T("2.400")   },
  { CBR_4800,     _T("4.800")   },
  { CBR_9600,     _T("9.600")   },
  { CBR_14400,   _T("14.400")   },
  { CBR_19200,   _T("19.200")   },
  { CBR_38400,   _T("38.400")   },
  { CBR_56000,   _T("56.000")   },
  { CBR_57600,   _T("57.600")   },
  { CBR_115200, _T("115.200")   },
  { CBR_128000, _T("128.000")   },
  { CBR_256000, _T("256.000")   }
};
//----------------------------------------------------------------------------
static value_name vParity[] =
{
  { EVENPARITY, _T("EVENPARITY")  },
  { MARKPARITY, _T("MARKPARITY")  },
  { NOPARITY,   _T("NOPARITY")    },
  { ODDPARITY,  _T("ODDPARITY")   },
  { SPACEPARITY,_T("SPACEPARITY") }
};
//----------------------------------------------------------------------------
static value_name vBitStop[] =
{
  { ONESTOPBIT,   _T("ONESTOPBIT")    },
  { ONE5STOPBITS, _T("ONE5STOPBITS")  },
  { TWOSTOPBITS,  _T("TWOSTOPBITS")   }
};
//----------------------------------------------------------------------------
static value_name vBitLen[] =
{
  { 5,  _T("5") },
  { 6,  _T("6") },
  { 7,  _T("7") },
  { 8,  _T("8") },
};
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
P_Param::P_Param(paramCom& par, DWORD& delay, PWin* parent, uint resId, HINSTANCE hinstance)
:
    PDialog(parent, resId, hinstance), Par(par), Delay(delay)
{
	#define MAX_BMP SIZE_A(idBmp)
  int idBmp[] = { IDB_BITMAP_DEF, IDB_BITMAP_OK, IDB_BITMAP_CANC };
  Bmp.setDim(MAX_BMP);
  for(int i = 0; i < MAX_BMP; ++i)
  	Bmp[i] = new PBitmap(idBmp[i], getHInstance());

  PVect<PBitmap*> imgLoad;
  imgLoad.setDim(1);

  imgLoad[0] = Bmp[0];
  new POwnBtnImage(this, IDC_BUTTON_DEFAULT, imgLoad, false);
  imgLoad[0] = Bmp[1];
  new POwnBtnImage(this, IDOK, imgLoad, false);
  imgLoad[0] = Bmp[2];
  new POwnBtnImage(this, IDCANCEL, imgLoad, false);
}
//----------------------------------------------------------------------------
P_Param::~P_Param()
{
  destroy();
  int nElem = Bmp.getElem();
  for(int i = 0; i < nElem; ++i)
  	delete Bmp[i];
}
//---------------------------------------------------------
static void findAndSetText(HWND cbx, LPCTSTR txt)
{
  int count = SendMessage(cbx, CB_GETCOUNT, 0, 0);
  TCHAR t[500];
  for(int i = 0; i < count; ++i) {
    SendMessage(cbx, CB_GETLBTEXT, i, (LPARAM)t);
    if(!_tcscmp(t, txt)) {
      SendMessage(cbx, CB_SETCURSEL, i, 0);
      break;
      }
    }
}
//----------------------------------------------------------------------------
#define SET_CBX_(bx, vn, p) \
    { \
    HWND hcbx = ::GetDlgItem(getHandle(), bx); \
    fillCBX(hcbx,vn, SIZE_A(vn));   \
    findAndSetText(hcbx, vn[Par.b.p].name); \
    }
//----------------------------------------------------------------------------
#define SET_PAR_(bx, vn, p) \
    { \
    HWND hcbx = ::GetDlgItem(getHandle(), bx);  \
    Par.b.p = static_cast<WORD>(fillPar(hcbx, SIZE_A(vn))); \
    }
//----------------------------------------------------------------------------
static int fillPar(HWND hcbx, int num)
{
  TCHAR txt[50];
  ::GetWindowText(hcbx, txt, SIZE_A(txt));
  for(int i=0; i < num; ++i) {
    TCHAR t[50];
    ::SendMessage(hcbx, CB_GETLBTEXT, (WPARAM)i, (LPARAM)t);
    if(!_tcscmp(txt,t))
      return i;
    }
  return 0;
}
//----------------------------------------------------------------------------
void P_Param::BNClickedOk()
{
  SET_PAR_(IDC_COMBOBOX_COM_PORT, vPort, port)
  SET_PAR_(IDC_COMBOBOX_BAUDRATE, vBaudRate, baud)
  SET_PAR_(IDC_COMBOBOX_BITSTOP,  vBitStop,  stop)
  SET_PAR_(IDC_COMBOBOX_DATA_LEN,  vBitLen,   len)
  SET_PAR_(IDC_COMBOBOX_PARITY,   vParity,   parity)
  Delay = GetDlgItemInt(*this, IDC_EDIT_MS_DELAY, 0, 0);
}
//----------------------------------------------------------------------------
static void fillCBX(HWND hcbx, value_name *v, int num)
{
  ::SendMessage(hcbx, CB_RESETCONTENT, 0, 0);

  for(int i = 0; i < num; ++i)
    ::SendMessage(hcbx, CB_ADDSTRING, 0, (LPARAM)(v[i].name));
}
//----------------------------------------------------------------------------
bool P_Param::create()
{
  if(!PDialog::create())
    return false;

	fillCtrl();
  SetDlgItemInt(*this, IDC_EDIT_MS_DELAY, Delay, 0);
  return true;
}
//----------------------------------------------------------------------------
void P_Param::fillCtrl()
{
  SET_CBX_(IDC_COMBOBOX_COM_PORT, vPort, port)
  SET_CBX_(IDC_COMBOBOX_BAUDRATE, vBaudRate, baud)
  SET_CBX_(IDC_COMBOBOX_BITSTOP,  vBitStop,  stop)
  SET_CBX_(IDC_COMBOBOX_DATA_LEN,  vBitLen,   len)
  SET_CBX_(IDC_COMBOBOX_PARITY,   vParity,   parity)
}
//----------------------------------------------------------------------------
LRESULT P_Param::windowProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch(message) {
    case WM_COMMAND:
      switch(LOWORD(wParam)) {
        case IDC_BUTTON_DEFAULT:
       		Par = getDefaultparamCom();
        	fillCtrl();
        	break;

        case IDOK:
          BNClickedOk();
        case IDCANCEL:
          EndDialog(hwnd, LOWORD(wParam));
          return 0;
        }
    }
  return PDialog::windowProc(hwnd, message, wParam, lParam);
}
//----------------------------------------------------------------------------
