//-------- progressBar.cpp ---------------------------------------------------
#define _WIN32_IE  0x0300
//----------------------------------------------------------------------------
#include "precHeader.h"
//----------------------------------------------------------------------------
#include <commctrl.h>
#include "progressBar.h"
#include "p_util.h"
#include "pOwnBtnImage.h"
//----------------------------------------------------------------------------
progressBar::progressBar(PWin* parent, LPCTSTR message, DWORD max_count, COLORREF bar, uint resId,  HINSTANCE hInstance)
  : baseClass(parent, resId, hInstance), barColor(bar),
  	Aborted(false), Message(str_newdup(message)), maxCount(max_count), oldFocus(0)
{
	#define MAX_BMP SIZE_A(idBmp)
  int idBmp[] = { IDB_BITMAP_CANC };
  Bmp.setDim(MAX_BMP);
  for(int i = 0; i < MAX_BMP; ++i)
  	Bmp[i] = new PBitmap(idBmp[i], getHInstance());

  PVect<PBitmap*> imgLoad;
  imgLoad.setDim(1);
  imgLoad[0] = Bmp[0];
  new POwnBtnImage(this, IDC_BUTTON_ABORT_COMM, imgLoad, false);
}
//----------------------------------------------------------------------------
progressBar::~progressBar()
{
  destroy();
  Aborted = true;
  delete []Message;
 	if(oldFocus && IsWindow(oldFocus))
  	SetFocus(oldFocus);
  int nElem = Bmp.getElem();
  for(int i = 0; i < nElem; ++i)
  	delete Bmp[i];
}
//----------------------------------------------------------------------------
//#if (_WIN32_IE >= 0x0300)
#define PBS_SMOOTH              0x01
#define PBS_VERTICAL            0x04
#define PBM_SETBARCOLOR         (WM_USER+9)
#define PBM_SETRANGE32          (WM_USER+6)
//#endif
bool progressBar::create()
{
 	oldFocus = GetFocus();
  if(!baseClass::create())
    return false;
	HWND child = GetDlgItem(*this, IDC_PROGRESSBAR_COMM);

  SendMessage(child, PBM_SETRANGE32, 0, (LPARAM) maxCount);
  SendMessage(child, PBM_SETBARCOLOR, 0, (LPARAM) barColor);

  return true;
}
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------
LRESULT progressBar::windowProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
  switch(message) {
		case WM_DESTROY:
		  Aborted = true;
      break;
		case WM_COMMAND:
    	switch(LOWORD(wParam)) {
		  	case IDC_BUTTON_ABORT_COMM:
				  Aborted = true;
         	DestroyWindow(hwnd);
		  		break;
        }
      break;

    }
  return baseClass::windowProc(hwnd, message, wParam, lParam);
}
//----------------------------------------------------------------------------
bool progressBar::setCount(DWORD count)
{
	if(Aborted)
		return false;

	SendMessage(GetDlgItem(*this, IDC_PROGRESSBAR_COMM), PBM_SETPOS, count, 0);

	TCHAR buff[500];
	wsprintf(buff, Message, count, maxCount);
	SetDlgItemText(*this, IDC_STATICTEXT_PROGRESS, buff);
	return true;
}
